VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3900
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6270
   LinkTopic       =   "Form1"
   ScaleHeight     =   3900
   ScaleWidth      =   6270
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      Height          =   975
      Left            =   0
      TabIndex        =   1
      Top             =   2880
      Width           =   6135
      Begin VB.TextBox txtMaxCol 
         Height          =   285
         Left            =   4800
         TabIndex        =   11
         Text            =   "4"
         Top             =   240
         Width           =   375
      End
      Begin VB.TextBox txtMinCol 
         Height          =   285
         Left            =   3480
         TabIndex        =   9
         Text            =   "1"
         Top             =   240
         Width           =   375
      End
      Begin VB.TextBox txtMaxRow 
         Height          =   285
         Left            =   2160
         TabIndex        =   7
         Text            =   "4"
         Top             =   240
         Width           =   375
      End
      Begin VB.TextBox txtMinRow 
         Height          =   285
         Left            =   840
         TabIndex        =   5
         Text            =   "2"
         Top             =   240
         Width           =   375
      End
      Begin VB.TextBox txtOut 
         Height          =   285
         Index           =   0
         Left            =   120
         TabIndex        =   3
         Top             =   600
         Visible         =   0   'False
         Width           =   375
      End
      Begin VB.CommandButton cmdCopy 
         Caption         =   "Copy"
         Default         =   -1  'True
         Height          =   375
         Left            =   5400
         TabIndex        =   2
         Top             =   240
         Width           =   615
      End
      Begin VB.Label Label1 
         Caption         =   "Max Col"
         Height          =   255
         Index           =   3
         Left            =   4080
         TabIndex        =   10
         Top             =   240
         Width           =   735
      End
      Begin VB.Label Label1 
         Caption         =   "Min Col"
         Height          =   255
         Index           =   2
         Left            =   2760
         TabIndex        =   8
         Top             =   240
         Width           =   735
      End
      Begin VB.Label Label1 
         Caption         =   "Max Row"
         Height          =   255
         Index           =   1
         Left            =   1440
         TabIndex        =   6
         Top             =   240
         Width           =   735
      End
      Begin VB.Label Label1 
         Caption         =   "Min Row"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   4
         Top             =   240
         Width           =   735
      End
   End
   Begin VB.TextBox txtIn 
      Height          =   285
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   375
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const MAX_ROW = 9
Private Const MAX_COL = 9
Private m_InBoxes(0 To MAX_ROW, 0 To MAX_COL) As TextBox

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Sub cmdCopy_Click()
Dim rmin As Integer
Dim rmax As Integer
Dim cmin As Integer
Dim cmax As Integer
Dim r As Integer
Dim c As Integer
Dim in_array() As Byte
Dim out_array() As Byte
Dim idx As Integer
Dim bytes_per_col As Long
Dim wid As Single

    rmin = CInt(txtMinRow.Text)
    rmax = CInt(txtMaxRow.Text)
    cmin = CInt(txtMinCol.Text)
    cmax = CInt(txtMaxCol.Text)

    ' Highlight the selected data.
    For r = 0 To MAX_ROW
        For c = 0 To MAX_COL
            m_InBoxes(r, c).BackColor = vbWhite
            m_InBoxes(r, c).ForeColor = vbBlack
        Next c
    Next r
    For r = rmin To rmax
        For c = cmin To cmax
            m_InBoxes(r, c).BackColor = vbBlack
            m_InBoxes(r, c).ForeColor = vbWhite
        Next c
    Next r

    ' Copy the inputs into in_array.
    ReDim in_array(0 To MAX_ROW, 0 To MAX_COL)
    For r = 0 To MAX_ROW
        For c = 0 To MAX_COL
            in_array(r, c) = CByte(m_InBoxes(r, c))
        Next c
    Next r
    ReDim out_array(0 To (rmax - rmin + 1) * (cmax - cmin + 1) - 1)

    ' Copy the data into out_array using MemCopy.
    bytes_per_col = rmax - rmin + 1
    idx = 0
    For c = cmin To cmax
        CopyMemory out_array(idx), in_array(rmin, c), bytes_per_col
        idx = idx + bytes_per_col
    Next c

    ' Display the results.
    For r = txtOut.UBound + 1 To idx - 1
        Load txtOut(r)
        Set txtOut(r).Container = Frame1
        txtOut(r).Move txtOut(r - 1).Left + txtOut(r - 1).Width + 60, txtOut(r - 1).Top
    Next r
    For r = idx To txtOut.UBound
        Unload txtOut(r)
    Next r
    For r = 0 To idx - 1
        txtOut(r).Text = Format$(out_array(r))
        txtOut(r).Visible = True
    Next r

    wid = txtOut(idx - 1).Left + txtOut(idx - 1).Width
    If wid < cmdCopy.Left + cmdCopy.Width Then wid = cmdCopy.Left + cmdCopy.Width
    Frame1.Width = wid + 120
    Width = Frame1.Width + Width - ScaleWidth
End Sub
Private Sub Form_Load()
Dim r As Integer
Dim c As Integer
Dim idx As Integer
Dim X As Single
Dim Y As Single
Dim dx As Single
Dim dy As Single

    dx = txtIn(0).Width + 0
    dy = txtIn(0).Height + 60

    idx = 0
    Y = txtIn(0).Top
    For r = 0 To MAX_ROW
        X = txtIn(0).Left
        For c = 0 To MAX_COL
            If idx > 0 Then Load txtIn(idx)
            txtIn(idx).Move X, Y
            txtIn(idx).Text = Format$(r) & Format$(c)
            txtIn(idx).Visible = True
            Set m_InBoxes(r, c) = txtIn(idx)
            idx = idx + 1
            X = X + dx
        Next c
        Y = Y + dy
    Next r

    Frame1.Top = m_InBoxes(MAX_ROW, MAX_COL).Top + txtIn(0).Height
    Width = Frame1.Width + Width - ScaleWidth
    Height = Frame1.Top + Frame1.Height + Height - ScaleHeight
End Sub
